# Desenho retangular em grade para DCELs

Trabalho de Formatura (2021) de André Victor dos Santos Nakazawa sob a disciplina MAC0499 do Instituto de Matemática e Estatística - Universidade de São Paulo (IME-USP). Este trabalho foi supervisionado pelo Prof. Dr. Carlos Eduardo Ferreira.

Página do projeto: https://linux.ime.usp.br/~andrevsn/mac0499/

## Módulos .py desenvolvidos

O desenvolvimento se deu em `Python 3.9.2`. Os seguintes módulos estão incluídos no diretório **codigo**.

### `PlaneGraph.py`

Implementação de DCEL (doubly connected edge list, ou listas de arestas duplamente ligadas), estrutura de dados que utilizamos para representar grafos planos.

### `RectangularDrawing.py`

Implementação do algoritmo de desenho retangular, sendo `DrawGraph` a função principal.

### `RectangularGridDrawing.py`

Implementação dos algoritmos para definição das coordenadas do desenho retangular, sendo `HorizontalSpanningTree` e `VerticalSpanningTree` as funções principais.

### `Plotters.py`

Funções que foram utilizadas para poder visualizar o grafo plano e as informações contidas nos seus vértices, arestas e faces. Também contém funções que foram utilizadas na geração da animação. As bibliotecas utilizadas foram `matplotlib 3.5.1` e `imageio 2.14.1`.

### `Generators.py`

Funções para geração de alguns grafos planos. Foram utilizados para teste do módulo `PlaneGraph.py` inicialmente.

### `Positioners.py`

Algumas heurísticas que foram testadas inicialmente na tentativa de atribuir coordenadas para grafos planos.

### `Utilities.py`

Funções genéricas utilizadas por outros módulos, como `Positioners.py` e `Generators.py` . Também contém as funções `intoargs` e `matrixtoargs` que utilizamos para facilitar a criação de entradas para teste.


Em **codigo** também podem ser encontrados notebooks (arquivos .ipynb) contendo exemplos de uso e teste das funções desenvolvidas. Durante o desenvolvimento, a versão do servidor `Jupyter` utilizado foi `6.2.0` com `IPython 7.20.0`.

## Desenhos de exemplo

Algumas animações .gif foram geradas para verificar o resultado dos algoritmos e estão incluídas no diretório **saida**. A construção de tais animações podem ser encontradas em `test_examples.ipynb`. 

Utilizamos arquivos `.in` e `.mtx` que se encontram no diretório **entrada** para geração das animações. Para mais informações sobre tais arquivos, consulte a documentação de `intoargs` e `matrixtoargs` em `Utilities.py`.
